Imports System.Runtime.InteropServices
Imports AddinExpress.OL

Public Class FolderPath

    Public Sub New()
        MyBase.New()

        InitializeComponent()

    End Sub

    Private FolderEntryID As String

    Private Sub FolderPath_ADXBeforeFormShow() Handles MyBase.ADXBeforeFormShow
        If OutlookDemo.AddinModule.CurrentInstance.RibbonButtonGoTo.Pressed Then
            Me.RegionState = ADXRegionState.Normal
        Else
            Me.RegionState = ADXRegionState.Hidden
        End If
    End Sub

    Private Sub FolderPath_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim objFolder As Outlook.MAPIFolder = Nothing
        Dim objItem As Object = Nothing

        FolderEntryID = String.Empty

        Me.FolderPathLink.Text = String.Empty

        Try
            objItem = InspectorObj.CurrentItem
            If objItem IsNot Nothing Then
                Try
                    objFolder = objItem.Parent
                    If objFolder IsNot Nothing Then
                        FolderEntryID = objFolder.EntryID
                        Me.FolderPathLink.Text = GetFolderPath(objFolder)
                    End If
                Finally
                    Marshal.ReleaseComObject(objItem)
                End Try
            End If
        Catch
        End Try
    End Sub

    Function GetFolderPath(ByVal objFolder As Outlook.MAPIFolder) As String
        Dim strFolderPath As String
        Dim objChild As Outlook.MAPIFolder
        Dim objParent As Outlook.MAPIFolder

        strFolderPath = "\" + objFolder.Name
        objChild = objFolder

        While objChild IsNot Nothing
            Try
                objParent = objChild.Parent
            Catch
                objParent = Nothing
            Finally
                If objChild IsNot Nothing Then
                    Marshal.ReleaseComObject(objChild)
                End If
            End Try
            If objParent Is Nothing Then Exit While
            strFolderPath = "\" + objParent.Name + strFolderPath
            objChild = objParent
        End While

        Return "\" + strFolderPath
    End Function

    Private Sub FolderPathLink_LinkClicked(sender As Object, e As Windows.Forms.LinkLabelLinkClickedEventArgs) Handles FolderPathLink.LinkClicked
        Dim olApp As Outlook._Application = Me.OutlookAppObj
        Dim parentFolder As Outlook.MAPIFolder = Nothing
        Dim ns As Outlook._NameSpace = Nothing
        Dim activeExplorer As Outlook._Explorer = Nothing

        Try
            ns = olApp.GetNamespace("MAPI")
            parentFolder = ns.GetFolderFromID(FolderEntryID, Type.Missing)
            activeExplorer = olApp.ActiveExplorer()
            activeExplorer.CurrentFolder = parentFolder
            activeExplorer.Activate()
        Catch
        Finally
            If ns IsNot Nothing Then Marshal.ReleaseComObject(ns)
            If activeExplorer IsNot Nothing Then Marshal.ReleaseComObject(activeExplorer)
            If parentFolder IsNot Nothing Then Marshal.ReleaseComObject(parentFolder)
        End Try
    End Sub
End Class
